#include <iostream>
#include <new>

#include "List.h"

using namespace std;

List::List() {
  cout << "> List() - construtor 1" << endl;
  head = NULL;
  maxsize = 10;
  size = 0;
}

List::List(int pMaxSize) {
  cout << "> List(int) - construtor 2" << endl;
  if (pMaxSize > 0) {
    head = NULL;
    maxsize = pMaxSize;
    //this->maxsize = pMaxSize;
    size = 0;
  } 
  else {
    List();
  }
}

List::~List() {
  cout << "< ~List() - destructor" << endl;
  NODE *p, *ant;
  p = head;
  ant = head;
  while (p!=NULL) {
    p = p->next;
    delete ant;
    ant = p;
  }
  
  head = NULL;
  size = 0;
  maxsize = 0;
}

int List::isEmpty() {
  return (size == 0); 
}

int List::isFull() {
  return (maxsize == size); 
}

void List::insertBegin(int pInsertValue) {
  if (isFull())
     return;
  
  NODE *p = new NODE;
  p->value = pInsertValue;
  p->next = head;
  head = p;
  size ++;
}

void List::printList() {
  NODE *p; 
  for (p = head; p != NULL; p = p->next) {
      cout << p->value << " ";    
  }  
  cout << endl;
}
