#include <iostream>
#include <new>

#include "TailList.h"

using namespace std;

TailList::TailList(int pMaxSize) : List(pMaxSize)
{
  // chama construtor da superclasse
  // TailList e um List
  cout << "> TailList(int) - construtor" << endl;
  tail = NULL;
}

TailList::~TailList() {
  cout << "< ~TailList() - destructor" << endl;
  tail = NULL;
}

void TailList::insertEnd(int pInsertValue) {
  if (isFull())
     return;
  
  if (isEmpty()) {
     List::insertBegin(pInsertValue);
     tail = head;
  }
  else {
     NODE *p = new NODE;
     p->value = pInsertValue;
     p->next = NULL;
     
     tail->next = p;
     tail = p;
     size ++;
  }
}

// override
// sobrescrita de metodo
void TailList::insertBegin(int pInsertValue) {
  if (isFull())
     return;
  
  if (isEmpty()) {
     List::insertBegin(pInsertValue);
     tail = head;
  }
  else {
     List::insertBegin(pInsertValue);
  }
}